﻿@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using OWebApplication.Pages.Tasks
@using System.Threading
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject ISnackbar _snackbar

<MudDialog>
    <TitleContent>
        <MudText Typo="Typo.h6">
            <MudIcon Icon="@Icons.Material.Filled.Edit" Class="mr-3 mb-n1"/>
            @_localizer["Налаштування завдання"]
        </MudText>
    </TitleContent>
    <DialogContent>
        @if (_editModel is not null)
        {
            <EditForm Model="@_editModel" OnValidSubmit="OnValidSubmitAsync">
                <DataAnnotationsValidator/>
                <MudCheckBox For="() => _editModel.Enabled" @bind-Checked="@_editModel.Enabled"
                             Label="@_localizer["Зробити завдання доступним для розв'язання"]"></MudCheckBox>
                
                <MudContainer Class="d-flex justify-end align-center pa-0 ma-0">
                    <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="Color.Primary"
                               StartIcon="@Icons.Material.Filled.Save">@_localizer["Зберегти"]</MudButton>
                </MudContainer>
            </EditForm>
        }
    </DialogContent>
    <DialogActions></DialogActions>
</MudDialog>


@code {
    private SemaphoreSlim _semaphore;
    
    [CascadingParameter] public MudDialogInstance MudDialog { get; set; }
    [Parameter] public Guid ProgrammingTaskId { get; set; }

    private ProgrammingTaskOptionsModel _editModel;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        
        MudDialog.SetOptions(new DialogOptions
        {
            CloseButton = true,
            DisableBackdropClick = true,
            FullScreen = false,
            FullWidth = true,
            MaxWidth = MaxWidth.Small,
            NoHeader = false,
            Position = DialogPosition.Center
        });
        
        var currentUserId = await GetCurrentUserIdAsync();
        var currentUserIsAdmin = await IsSuperUserAsync(currentUserId);
        
        if (!currentUserIsAdmin)
        {
            _snackbar.Add(_localizer["Ви не маєте необхідних прав доступу для виконання запитуваної операції!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive");
            MudDialog.Close();
            return;
        }

        _semaphore = new SemaphoreSlim(1, 1);
        _editModel = null;
        
        async Task<Guid> GetCurrentUserIdAsync()
        {
            var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            return new Guid(_userManager.GetUserId(authenticationState.User));
        }

        async Task<bool> IsSuperUserAsync(Guid userId)
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            return await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
                userId, UserType.SuperUser);
        }
    }

    protected override async Task OnParametersSetAsync()
    {
        await base.OnParametersSetAsync();
        await using var databaseContext = _dbContextFactory.CreateDbContext();
        
        if (!await IsProgrammingTaskExistsAsync(databaseContext))
        {
            _snackbar.Add(_localizer["Запитуваного вами завдання не знайдено у системі!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive");
            MudDialog.Close();
            return;
        }

        await LoadProgrammingTaskOptionsAsync(databaseContext);
        StateHasChanged();

        // ReSharper disable once VariableHidesOuterVariable
        async Task<bool> IsProgrammingTaskExistsAsync(OvertestDatabaseContext databaseContext)
        {
            return await databaseContext.ProgrammingTasks.AnyAsync(t => t.Id == ProgrammingTaskId);
        }
    }

    private async Task LoadProgrammingTaskOptionsAsync(OvertestDatabaseContext databaseContext)
    {
        _editModel = await databaseContext.ProgrammingTasks.AsNoTracking()
            .Where(t => t.Id == ProgrammingTaskId)
            .Select(s => new ProgrammingTaskOptionsModel
            {
                Enabled = s.Enabled
            }).FirstAsync();
    }

    private async Task OnValidSubmitAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            var taskDbObject = new ProgrammingTask
            {
                Id = ProgrammingTaskId,
                Enabled = _editModel.Enabled
            };

            databaseContext.ProgrammingTasks.Attach(taskDbObject);
            databaseContext.Entry(taskDbObject).Property(p => p.Enabled).IsModified = true;
            await databaseContext.SaveChangesAsync();

            _snackbar.Add(_localizer["Налаштування завдання успішно збережено!"],
                Severity.Success, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo($"/tasks/view/{ProgrammingTaskId}");
            MudDialog.Close();
        }
        catch (Exception)
        {
            _snackbar.Add(_localizer[
                "При збереженні нових налаштувань виникла непередбачувана помилка. " +
                "Перевірте правильність наданої інформації і повторіть вашу спробу."],
                Severity.Error);
            MudDialog.Close();
        }
        finally { _semaphore.Release(); }
    }
    
    private class ProgrammingTaskOptionsModel
    {
        public bool Enabled { get; set; }
    }
}